/*
--	Copyright (c) 2007 - 2021 by Victor Shulman.
--	Written by Victor Shulman.  Not derived from licensed software.
--
--	Permission is granted to anyone to use this software for any
--	purpose on any computer system, and to redistribute it in any way,
--	subject to the following restrictions:
--
--	1. The author is not responsible for the consequences of use of
--		this software, no matter how awful, even if they arise
--		from defects in it.
--
--	2. The origin of this software must not be misrepresented, either
--		by explicit claim or by omission.
--
--	3. This notice must not be removed or altered.
*/
package com.dbtimes.dw.sourceloader

private[sourceloader] object ActionProcessorFactory {

  private[sourceloader] def getLoadActionProcessor(action: LoadAction): ActionProcessor = {
    if (action.getIsFileSourceCsv)
      new ProcessorOfCsvFileSource(action)
    else if (action.getIsSqlServerSource)
      new ProcessorOfSqlServerSource(action)
    else
      throw new RuntimeException("Loader ERROR: unhandled source type in load action" + action.getName)
  }
}
